Index: trunk/LMDZ.MARS/libf/aeronomars/paramfoto_compact.F
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/paramfoto_compact.F	(revision 1265)
+++ trunk/LMDZ.MARS/libf/aeronomars/paramfoto_compact.F	(revision 1266)
@@ -2,24 +2,21 @@
 
       subroutine paramfoto_compact
-     $(ig,chemthermod,lswitch,tx,timestep,zenit,zx,rm,nesptherm)
+     $(ig,nlayer,chemthermod,lswitch,tx,timestep,zenit,zx,rm,nesptherm)
   
 c     may 2008      FGG+MALV,GG             
 c**********************************************************************
 
+      use iono_h
+      use param_v4_h
       implicit none
-      include "dimensions.h"
-      include "dimphys.h"
-      include 'param.h'
-      include 'param_v4.h'
-      include 'iono.h'
 
 c     arguments
 
-      integer lswitch,ig,nesptherm,chemthermod
-      real zdens(nlayermx)
-      real tx(nlayermx)
+      integer lswitch,ig,nesptherm,chemthermod,nlayer
+      real zdens(nlayer)
+      real tx(nlayer)
       real zenit
-      real zx(nlayermx)
-      real rm(nlayermx,nesptherm)
+      real zx(nlayer)
+      real rm(nlayer,nesptherm)
       real timestep
 
@@ -67,7 +64,7 @@
       real*8  delectx,dnplusx
 
-      real*8  jdistot8(nabs,nlayermx)
-      real*8  jdistot8_b(nabs,nlayermx)
-      real*8  jion8(nabs,nlayermx,4)
+      real*8  jdistot8(nabs,nlayer)
+      real*8  jdistot8_b(nabs,nlayer)
+      real*8  jion8(nabs,nlayer,4)
       real*8  tx8
 	  
@@ -76,11 +73,11 @@
       real*8  alfa_laststep, IonMostAbundant
 
-      real*8  tmin(nlayermx)
+      real*8  tmin(nlayer)
       real*8  fmargin1,critere
 
-      integer compmin(nlayermx)
+      integer compmin(nlayer)
       integer i,j,k
       integer numpasos
-      integer n_comp_en_EQ(nlayermx), paso
+      integer n_comp_en_EQ(nlayer), paso
 
 ! Tracer indexes in the thermospheric chemistry:
@@ -124,5 +121,5 @@
       timefrac_sec=dble(timestep)
 
-      do i=nlayermx,lswitch,-1
+      do i=nlayer,lswitch,-1
 c     Concentrations to real*8
 
@@ -179,5 +176,5 @@
          !from photoabsorption rates and ionization-to-dissociation 
          !branching ratios
-         call phdisrate(ig,chemthermod,zenit,i)   
+         call phdisrate(ig,nlayer,chemthermod,zenit,i)   
          ! Conversion to double precision
          do j=1,nabs
@@ -194,5 +191,5 @@
 		 
          !Lifetimes and temporal integration 
-         call lifetimes(ig,i,chemthermod,zenit,zx,
+         call lifetimes(ig,i,nlayer,chemthermod,zenit,zx,
      $        jdistot8,jdistot8_b,jion8,
      $        tmin(i),compmin(i), 
@@ -220,7 +217,6 @@
         endif   !Of chemthermod.eq.3
 
-         call timemarching ( ig,i,chemthermod,n_comp_en_EQ,compmin,
-     $       tmin,timefrac_sec, deltat,fmargin1)
-
+         call timemarching ( ig,i,nlayer,chemthermod,n_comp_en_EQ,
+     .       compmin,tmin,timefrac_sec, deltat,fmargin1)
 
          !Number of timesteps
@@ -300,5 +296,5 @@
             end if
             !Calculation of productions and losses
-            call prodsandlosses ( ig, i , chemthermod,zenit, zx,
+            call prodsandlosses (ig,i,nlayer,chemthermod,zenit, zx,
      &                 jdistot8, jdistot8_b, jion8,
      &                              co2xinput, o2xinput, o3pxinput,
@@ -430,5 +426,5 @@
             !Third, those species (among the 16 that can be in PE) that are in PE
             call EF_oscilacion
-     &           ( ig,i, paso,chemthermod,zenit, zx,
+     &           ( ig,i,nlayer, paso,chemthermod,zenit, zx,
      &           jdistot8, jdistot8_b,jion8,
      &           deltat,
@@ -1181,20 +1177,26 @@
 c**********************************************************************
 
-      subroutine phdisrate(ig,chemthermod,zenit,i)
+      subroutine phdisrate(ig,nlayer,chemthermod,zenit,i)
 
 c     apr 2002       fgg           first version
 c**********************************************************************
 
+      use param_v4_h, only: ninter,nabs,
+     .    jfotsout,fluxtop,
+     .    jion,jdistot,jdistot_b,
+     .    efdisco2,efdiso2,efdish2o,
+     .    efdish2o2,efdish2,efdiso3,
+     .    efdiso,efdisn,efdish,
+     .    efdisno,efdisn2,efdisno2,
+     .    efdisco,efionco2,efionn2,
+     .    efionco,efiono3p,efionn,
+     .    efionno,efionh
 
       implicit none
-      include "dimensions.h"
-      include "dimphys.h"
-      include 'param.h'
-      include 'param_v4.h'
 
 c     arguments
 
       integer         i                !altitude
-      integer         ig,chemthermod
+      integer         ig,chemthermod,nlayer
       real            zenit
 
@@ -1203,5 +1205,5 @@
       integer         inter,iz,j
       real            lambda
-      real            jdis(nabs,ninter,nlayermx)
+      real            jdis(nabs,ninter,nlayer)
       character*1     dn
 
@@ -1388,10 +1390,15 @@
 c***************************************************************************
 
-	
+        use param_v4_h, only: rcoef,
+     .  ch2, ch3, ch4, ch5, ch7,ch9,ch10,ch11,ch13,ch14,ch15,ch18,
+     .  ch19,ch20,ch21,ch22,ch23,ch24,ch30,ch31,ch32,ch33,ch34,
+     .  ch35,ch36,ch37,ch38,ch39,ch40,ch41,ch42,ch43,ch45,
+     .  ch46,ch47,ch48,ch49,ch50,ch55,ch56,ch57,ch58,ch59,ch62,
+     .  ch63,ch64,ch65,ch66,ch67,ch68,ch69,ch70,ch71,
+     .  ch72,ch73,ch74,ch75,ch76,ch85,ch86,ch87
+
+
+
 	implicit none
-	include "dimensions.h"
-	include "dimphys.h"
-	include 'param.h'
-	include 'param_v4.h'
 
 c Arguments 	
@@ -2010,5 +2017,5 @@
 
       subroutine lifetimes
-     &   ( ig,i,chemthermod,zenit,zx,jdistot8, jdistot8_b, jion8,
+     &   ( ig,i,nlayer,chemthermod,zenit,zx,jdistot8, jdistot8_b, jion8,
      $     xtmin, xcompmin, xn_comp_en_EQ,
      $     co2xini,o2xini,o3pxini,coxini,hxini,ohxini,ho2xini,h2xini,
@@ -2028,22 +2035,20 @@
 c**********************************************************************
 
+      use iono_h
+      use param_v4_h
+
       implicit none
 
-      include "dimensions.h"
-      include "dimphys.h"
-      include 'param.h'
-      include 'param_v4.h'
-      include 'iono.h'
       include 'callkeys.h'
 
 c     arguments
 c
-      integer   i,ig                                  ! I. Layer  
+      integer   i,ig,nlayer                               ! I. Layer  
       integer   chemthermod
       real      zenit
-      real      zx(nlayermx)
-      real*8    jdistot8(nabs,nlayermx)                  ! I.
-      real*8    jdistot8_b(nabs,nlayermx)                ! I.
-      real*8    jion8(nabs,nlayermx,4)                ! I.
+      real      zx(nlayer)
+      real*8    jdistot8(nabs,nlayer)                  ! I.
+      real*8    jdistot8_b(nabs,nlayer)                ! I.
+      real*8    jion8(nabs,nlayer,4)                ! I.
 
       real*8    xtmin                         ! O. 
@@ -2714,5 +2719,5 @@
 c**********************************************************************
 
-      subroutine timemarching( ig,i,chemthermod,n_comp_en_EQ,
+      subroutine timemarching( ig,i,nlayer,chemthermod,n_comp_en_EQ,
      $     compmin,tmin,timefrac_sec, deltat,fmargin1 ) 
 
@@ -2725,19 +2730,20 @@
 c**********************************************************************
 
+      use iono_h
+      use param_v4_h, only: tminco2,tmino2,tmino3p,tminco,tminh,tminoh,
+     .  tminho2,tminh2,tminh2o,tmino1d,tminh2o2,tmino3,tminn,tminno,
+     .  tminno2,tminn2,tminn2d,tminco2plus,tminoplus,tmino2plus,
+     .  tmincoplus,tmincplus,tminnplus,tminnoplus,tminn2plus,
+     .  tminhplus,tminhco2plus
+
       implicit none
-
-      include "dimensions.h"
-      include "dimphys.h"
-      include 'param.h'
-      include 'param_v4.h'
-      include 'iono.h'
 
 c     arguments
 c
-      integer   i,ig                              ! I. Layer  
+      integer   i,ig,nlayer                              ! I. Layer  
       integer   chemthermod
-      integer   n_comp_en_EQ(nlayermx)         ! Number of species in PE
-      integer   compmin(nlayermx)              ! Species with minimum lifetime
-      real*8    tmin(nlayermx)                 ! Minimum lifetime
+      integer   n_comp_en_EQ(nlayer)         ! Number of species in PE
+      integer   compmin(nlayer)              ! Species with minimum lifetime
+      real*8    tmin(nlayer)                 ! Minimum lifetime
       real*8    timefrac_sec                   ! I. 
       real*8    deltat                         ! O. TimeMarching step
@@ -2893,5 +2899,5 @@
 c**********************************************************************
 
-      subroutine prodsandlosses ( ig,i,chemthermod,zenit,zx,
+      subroutine prodsandlosses ( ig,i,nlayer,chemthermod,zenit,zx,
      &                 jdistot8, jdistot8_b, jion8,
      &                              co2xinput, o2xinput, o3pxinput,
@@ -2916,20 +2922,17 @@
 c**********************************************************************
 
+      use param_v4_h
       implicit none
-      include "dimensions.h"
-      include "dimphys.h"
-      include 'param.h'
-      include 'param_v4.h'
 
 c     arguments
 c
-      integer   ig
+      integer   ig,nlayer
       integer   i                                 ! I. Layer  
       integer   chemthermod
-      real      zx(nlayermx)
+      real      zx(nlayer)
       real      zenit
-      real*8    jdistot8(nabs,nlayermx)
-      real*8    jdistot8_b(nabs,nlayermx)
-      real*8    jion8(nabs,nlayermx,4)
+      real*8    jdistot8(nabs,nlayer)
+      real*8    jdistot8_b(nabs,nlayer)
+      real*8    jion8(nabs,nlayer,4)
       real*8    co2xinput,o2xinput,o3pxinput,coxinput
       real*8    ho2xinput,h2xinput,hxinput,ohxinput
@@ -2939,5 +2942,4 @@
       real*8    cplusxinput,noplusxinput,n2plusxinput,hplusxinput
       real*8    electxinput,nplusxinput,hco2plusxinput
-
 
 c     local variables
@@ -4128,5 +4130,5 @@
 
       subroutine EF_oscilacion
-     &               (ig,i,paso,chemthermod,zenit, zx,
+     &               (ig,i,nlayer,paso,chemthermod,zenit, zx,
      &                 jdistot8, jdistot8_b,jion8, 
      &                 tminaux, 
@@ -4170,25 +4172,28 @@
 c**********************************************************************
 
+      use iono_h
+      use param_v4_h, only: nabs,
+     .  ch2, ch3, ch4, ch5, ch7,ch9,ch10,ch11,ch13,ch14,ch15,ch18,
+     .  ch19,ch20,ch21,ch22,ch23,ch24,ch30,ch31,ch32,ch33,ch34,
+     .  ch35,ch36,ch37,ch38,ch39,ch40,ch41,ch42,ch43,ch45,
+     .  ch46,ch47,ch48,ch49,ch50,ch55,ch56,ch57,ch58,ch59,ch62,
+     .  ch63,ch64,ch65,ch66,ch67,ch68,ch69,ch70,ch71,
+     .  ch72,ch73,ch74,ch75,ch76,ch85,ch86,ch87
+
+
       implicit none
 
-      include "dimensions.h"
-      include "dimphys.h"
-      include 'param.h'
-      include 'param_v4.h'
-      include 'iono.h'
-
-
 c     arguments
       
-      integer   ig
+      integer   ig,nlayer
       integer   i         ! I. Layer                              
       integer   paso      ! I. paso temporal del timemarching, 1,numpasos
       integer   chemthermod
       real*8    tminaux   ! I.
-      real      zx(nlayermx)
+      real      zx(nlayer)
       real      zenit
-      real*8    jdistot8(nabs,nlayermx)                  ! I.
-      real*8    jdistot8_b(nabs,nlayermx)                ! I.
-      real*8    jion8(nabs,nlayermx,4)
+      real*8    jdistot8(nabs,nlayer)                  ! I.
+      real*8    jdistot8_b(nabs,nlayer)                ! I.
+      real*8    jion8(nabs,nlayer,4)
 
       real*8    co2xoutput,o2xoutput,o3pxoutput,coxoutput,h2xoutput
@@ -4277,4 +4282,14 @@
       external ionsec_o2plus
       real*8   ionsec_o2plus
+
+      external avg
+      real*8   avg
+
+      external dif
+      real*8   dif
+
+      real*8 log1
+      real*8 log2
+      real*8 log3
 
 ccccccccccccccc CODE STARTS 
@@ -4712,16 +4727,14 @@
             
             if (o1d_eq(i).eq.'Y') then
-               avg_pares = ( dlog10(o1dxpares(1)) +
-     &              dlog10(o1dxpares(2)) +
-     &              dlog10(o1dxpares(3)) )*0.333
-               dif_pares = ( abs(dlog10(o1dxpares(1))-avg_pares) + 
-     &              abs(dlog10(o1dxpares(2))-avg_pares) +   
-     &              abs(dlog10(o1dxpares(3))-avg_pares) ) * 0.333   
-               avg_impar = ( dlog10(o1dximpar(1)) + 
-     &              dlog10(o1dximpar(2)) +
-     &              dlog10(o1dximpar(3)) )*0.333
-               dif_impar = ( abs(dlog10(o1dximpar(1))-avg_impar) + 
-     &              abs(dlog10(o1dximpar(2))-avg_impar) +   
-     &              abs(dlog10(o1dximpar(3))-avg_impar) ) * 0.333
+               log1 = dlog10(o1dxpares(1))
+               log2 = dlog10(o1dxpares(2))
+               log3 = dlog10(o1dxpares(3))
+               avg_pares = avg(log1,log2,log3)
+               dif_pares = dif(log1,log2,log3,avg_pares)
+               log1 = dlog10(o1dximpar(1))
+               log2 = dlog10(o1dximpar(2))
+               log3 = dlog10(o1dximpar(3))
+               avg_impar = avg(log1,log2,log3)
+               dif_impar = dif(log1,log2,log3,avg_impar)
                dispersion = dif_pares + dif_impar
                dif_pares_impar = abs(avg_pares-avg_impar)
@@ -4733,16 +4746,14 @@
             
             if (oh_eq(i).eq.'Y') then
-               avg_pares = ( dlog10(ohxpares(1)) +
-     &              dlog10(ohxpares(2)) +
-     &              dlog10(ohxpares(3)) )*0.333
-               dif_pares = ( abs(dlog10(ohxpares(1))-avg_pares) + 
-     &              abs(dlog10(ohxpares(2))-avg_pares) +   
-     &              abs(dlog10(ohxpares(3))-avg_pares) ) * 0.333   
-               avg_impar = ( dlog10(ohximpar(1)) + 
-     &              dlog10(ohximpar(2)) +
-     &              dlog10(ohximpar(3)) )*0.333
-               dif_impar = ( abs(dlog10(ohximpar(1))-avg_impar) + 
-     &              abs(dlog10(ohximpar(2))-avg_impar) +   
-     &              abs(dlog10(ohximpar(3))-avg_impar) ) * 0.333
+               log1 = dlog10(ohxpares(1))
+               log2 = dlog10(ohxpares(2))
+               log3 = dlog10(ohxpares(3))
+               avg_pares = avg(log1,log2,log3)
+               dif_pares = dif(log1,log2,log3,avg_pares)
+               log1 = dlog10(ohximpar(1))
+               log2 = dlog10(ohximpar(2))
+               log3 = dlog10(ohximpar(3))
+               avg_impar = avg(log1,log2,log3)
+               dif_impar = dif(log1,log2,log3,avg_impar)
                dispersion = dif_pares + dif_impar
                dif_pares_impar = abs(avg_pares-avg_impar)
@@ -4755,16 +4766,14 @@
             
             if (ho2_eq(i).eq.'Y') then
-               avg_pares = ( dlog10(ho2xpares(1)) +
-     &              dlog10(ho2xpares(2)) +
-     &              dlog10(ho2xpares(3)) )*0.333
-               dif_pares = ( abs(dlog10(ho2xpares(1))-avg_pares) + 
-     &              abs(dlog10(ho2xpares(2))-avg_pares) +   
-     &              abs(dlog10(ho2xpares(3))-avg_pares) ) * 0.333   
-               avg_impar = ( dlog10(ho2ximpar(1)) + 
-     &              dlog10(ho2ximpar(2)) +
-     &              dlog10(ho2ximpar(3)) )*0.333
-               dif_impar = ( abs(dlog10(ho2ximpar(1))-avg_impar) + 
-     &              abs(dlog10(ho2ximpar(2))-avg_impar) +   
-     &              abs(dlog10(ho2ximpar(3))-avg_impar) ) * 0.333
+               log1 = dlog10(ho2xpares(1))
+               log2 = dlog10(ho2xpares(2))
+               log3 = dlog10(ho2xpares(3))
+               avg_pares = avg(log1,log2,log3)
+               dif_pares = dif(log1,log2,log3,avg_pares)
+               log1 = dlog10(ho2ximpar(1))
+               log2 = dlog10(ho2ximpar(2))
+               log3 = dlog10(ho2ximpar(3))
+               avg_impar = avg(log1,log2,log3)
+               dif_impar = dif(log1,log2,log3,avg_impar)
                dispersion = dif_pares + dif_impar
                dif_pares_impar = abs(avg_pares-avg_impar)
@@ -4776,16 +4785,14 @@
             
             if (h_eq(i).eq.'Y') then
-               avg_pares = ( dlog10(hxpares(1)) +
-     &              dlog10(hxpares(2)) +
-     &              dlog10(hxpares(3)) )*0.333
-               dif_pares = ( abs(dlog10(hxpares(1))-avg_pares) + 
-     &              abs(dlog10(hxpares(2))-avg_pares) +   
-     &              abs(dlog10(hxpares(3))-avg_pares) ) * 0.333   
-               avg_impar = ( dlog10(hximpar(1)) + 
-     &              dlog10(hximpar(2)) + 
-     &              dlog10(hximpar(3)) )*0.333
-               dif_impar = ( abs(dlog10(hximpar(1))-avg_impar) + 
-     &              abs(dlog10(hximpar(2))-avg_impar) +   
-     &              abs(dlog10(hximpar(3))-avg_impar) ) * 0.333
+               log1 = dlog10(hxpares(1))
+               log2 = dlog10(hxpares(2))
+               log3 = dlog10(hxpares(3))
+               avg_pares = avg(log1,log2,log3)
+               dif_pares = dif(log1,log2,log3,avg_pares)
+               log1 = dlog10(hximpar(1))
+               log2 = dlog10(hximpar(2))
+               log3 = dlog10(hximpar(3))
+               avg_impar = avg(log1,log2,log3)
+               dif_impar = dif(log1,log2,log3,avg_impar)
                dispersion = dif_pares + dif_impar
                dif_pares_impar = abs(avg_pares-avg_impar)
@@ -4799,16 +4806,14 @@
             if(chemthermod.ge.2) then
                if (n2d_eq(i).eq.'Y') then
-                  avg_pares = ( dlog10(n2dxpares(1)) +
-     &                 dlog10(n2dxpares(2)) +
-     &                 dlog10( n2dxpares(3)) )*0.333
-                  dif_pares = ( abs(dlog10(n2dxpares(1))-avg_pares) + 
-     &                 abs(dlog10(n2dxpares(2))-avg_pares) +   
-     &                 abs(dlog10(n2dxpares(3))-avg_pares) ) * 0.333   
-                  avg_impar = ( dlog10(n2dximpar(1)) + 
-     &                 dlog10(n2dximpar(2)) +
-     &                 dlog10( n2dximpar(3)) )*0.333
-                  dif_impar = ( abs(dlog10(n2dximpar(1))-avg_impar) + 
-     &                 abs(dlog10(n2dximpar(2))-avg_impar) +   
-     &                 abs(dlog10(n2dximpar(3))-avg_impar) ) * 0.333
+                  log1 = dlog10(n2dxpares(1))
+                  log2 = dlog10(n2dxpares(2))
+                  log3 = dlog10(n2dxpares(3))
+                  avg_pares = avg(log1,log2,log3)
+                  dif_pares = dif(log1,log2,log3,avg_pares)
+                  log1 = dlog10(n2dximpar(1))
+                  log2 = dlog10(n2dximpar(2))
+                  log3 = dlog10(n2dximpar(3))
+                  avg_impar = avg(log1,log2,log3)
+                  dif_impar = dif(log1,log2,log3,avg_impar)
                   dispersion = dif_pares + dif_impar
                   dif_pares_impar = abs(avg_pares-avg_impar)
@@ -4820,16 +4825,14 @@
             
                if (no2_eq(i).eq.'Y') then
-                  avg_pares = (dlog10(no2xpares(1)) + 
-     &                 dlog10(no2xpares(2)) +
-     &                 dlog10( no2xpares(3)) )*0.333
-                  dif_pares = ( abs(dlog10(no2xpares(1))-avg_pares) + 
-     &                 abs(dlog10(no2xpares(2))-avg_pares) +   
-     &                 abs(dlog10(no2xpares(3))-avg_pares) ) * 0.333   
-                  avg_impar = ( dlog10(no2ximpar(1)) + 
-     &                 dlog10(no2ximpar(2)) +
-     &                 dlog10( no2ximpar(3)) )*0.333
-                  dif_impar = ( abs(dlog10(no2ximpar(1))-avg_impar) + 
-     &                 abs(dlog10(no2ximpar(2))-avg_impar) +   
-     &                 abs(dlog10(no2ximpar(3))-avg_impar) ) * 0.333
+                  log1 = dlog10(no2xpares(1))
+                  log2 = dlog10(no2xpares(2))
+                  log3 = dlog10(no2xpares(3))
+                  avg_pares = avg(log1,log2,log3)
+                  dif_pares = dif(log1,log2,log3,avg_pares)
+                  log1 = dlog10(no2ximpar(1))
+                  log2 = dlog10(no2ximpar(2))
+                  log3 = dlog10(no2ximpar(3))
+                  avg_impar = avg(log1,log2,log3)
+                  dif_impar = dif(log1,log2,log3,avg_impar)
                   dispersion = dif_pares + dif_impar
                   dif_pares_impar = abs(avg_pares-avg_impar)
@@ -4846,16 +4849,14 @@
             if(chemthermod.eq.3) then
                if (cplus_eq(i).eq.'Y') then
-                  avg_pares = ( dlog10(cplusxpares(1)) +
-     &                 dlog10(cplusxpares(2)) +
-     &                 dlog10(cplusxpares(3)) ) * 0.333
-                  dif_pares = ( abs(dlog10(cplusxpares(1))-avg_pares) + 
-     &                 abs(dlog10(cplusxpares(2))-avg_pares) +   
-     &                 abs(dlog10(cplusxpares(3))-avg_pares) ) * 0.333   
-                  avg_impar = ( dlog10(cplusximpar(1)) + 
-     &                 dlog10(cplusximpar(2)) +
-     &                 dlog10(cplusximpar(3)) ) * 0.333
-                  dif_impar = ( abs(dlog10(cplusximpar(1))-avg_impar) + 
-     &                 abs(dlog10(cplusximpar(2))-avg_impar) +   
-     &                 abs(dlog10(cplusximpar(3))-avg_impar) ) * 0.333
+                  log1 = dlog10(cplusxpares(1))
+                  log2 = dlog10(cplusxpares(2))
+                  log3 = dlog10(cplusxpares(3))
+                  avg_pares = avg(log1,log2,log3)
+                  dif_pares = dif(log1,log2,log3,avg_pares)
+                  log1 = dlog10(cplusximpar(1))
+                  log2 = dlog10(cplusximpar(2))
+                  log3 = dlog10(cplusximpar(3))
+                  avg_impar = avg(log1,log2,log3)
+                  dif_impar = dif(log1,log2,log3,avg_impar)
                   dispersion = dif_pares + dif_impar
                   dif_pares_impar = abs(avg_pares-avg_impar)
@@ -4867,16 +4868,14 @@
                
                if (coplus_eq(i).eq.'Y') then
-                  avg_pares = ( dlog10(coplusxpares(1)) +
-     &                 dlog10(coplusxpares(2)) +
-     &                 dlog10(coplusxpares(3)) )*0.333
-                  dif_pares = ( abs(dlog10(coplusxpares(1))-avg_pares)+ 
-     &                 abs(dlog10(coplusxpares(2))-avg_pares) +   
-     &                 abs(dlog10(coplusxpares(3))-avg_pares) ) * 0.333   
-                  avg_impar = ( dlog10(coplusximpar(1)) + 
-     &                 dlog10(coplusximpar(2)) +
-     &                 dlog10(coplusximpar(3)) )*0.333
-                  dif_impar = ( abs(dlog10(coplusximpar(1))-avg_impar)+ 
-     &                 abs(dlog10(coplusximpar(2))-avg_impar) +   
-     &                 abs(dlog10(coplusximpar(3))-avg_impar) ) * 0.333
+                  log1 = dlog10(coplusxpares(1))
+                  log2 = dlog10(coplusxpares(2))
+                  log3 = dlog10(coplusxpares(3))
+                  avg_pares = avg(log1,log2,log3)
+                  dif_pares = dif(log1,log2,log3,avg_pares)
+                  log1 = dlog10(coplusximpar(1))
+                  log2 = dlog10(coplusximpar(2))
+                  log3 = dlog10(coplusximpar(3))
+                  avg_impar = avg(log1,log2,log3)
+                  dif_impar = dif(log1,log2,log3,avg_impar)
                   dispersion = dif_pares + dif_impar
                   dif_pares_impar = abs(avg_pares-avg_impar)
@@ -4888,16 +4887,14 @@
                
                if (oplus_eq(i).eq.'Y') then
-                  avg_pares = ( dlog10(oplusxpares(1)) +
-     &                 dlog10(oplusxpares(2)) +
-     &                 dlog10( oplusxpares(3)) )*0.333
-                  dif_pares = ( abs(dlog10(oplusxpares(1))-avg_pares) + 
-     &                 abs(dlog10(oplusxpares(2))-avg_pares) +   
-     &                 abs(dlog10(oplusxpares(3))-avg_pares) ) * 0.333   
-                  avg_impar = ( dlog10(oplusximpar(1)) + 
-     &                 dlog10(oplusximpar(2)) +
-     &                 dlog10(oplusximpar(3)) )*0.333
-                  dif_impar = ( abs(dlog10(oplusximpar(1))-avg_impar) + 
-     &                 abs(dlog10(oplusximpar(2))-avg_impar) +   
-     &                 abs(dlog10(oplusximpar(3))-avg_impar) ) * 0.333
+                  log1 = dlog10(oplusxpares(1))
+                  log2 = dlog10(oplusxpares(2))
+                  log3 = dlog10(oplusxpares(3))
+                  avg_pares = avg(log1,log2,log3)
+                  dif_pares = dif(log1,log2,log3,avg_pares)
+                  log1 = dlog10(oplusximpar(1))
+                  log2 = dlog10(oplusximpar(2))
+                  log3 = dlog10(oplusximpar(3))
+                  avg_impar = avg(log1,log2,log3)
+                  dif_impar = dif(log1,log2,log3,avg_impar)
                   dispersion = dif_pares + dif_impar
                   dif_pares_impar = abs(avg_pares-avg_impar)
@@ -4909,16 +4906,14 @@
                
                if (n2plus_eq(i).eq.'Y') then
-                  avg_pares = ( dlog10(n2plusxpares(1)) +
-     &                 dlog10(n2plusxpares(2)) +
-     &                 dlog10(n2plusxpares(3)) )*0.333
-                  dif_pares = ( abs(dlog10(n2plusxpares(1))-avg_pares)+ 
-     &                 abs(dlog10(n2plusxpares(2))-avg_pares) +   
-     &                 abs(dlog10(n2plusxpares(3))-avg_pares) ) * 0.333   
-                  avg_impar = ( dlog10(n2plusximpar(1)) + 
-     &                 dlog10(n2plusximpar(2))+
-     &                 dlog10(n2plusximpar(3)) )*0.333
-                  dif_impar = ( abs(dlog10(n2plusximpar(1))-avg_impar)+ 
-     &                 abs(dlog10(n2plusximpar(2))-avg_impar) +   
-     &                 abs(dlog10(n2plusximpar(3))-avg_impar) ) * 0.333
+                  log1 = dlog10(n2plusxpares(1))
+                  log2 = dlog10(n2plusxpares(2))
+                  log3 = dlog10(n2plusxpares(3))
+                  avg_pares = avg(log1,log2,log3)
+                  dif_pares = dif(log1,log2,log3,avg_pares)
+                  log1 = dlog10(n2plusximpar(1))
+                  log2 = dlog10(n2plusximpar(2))
+                  log3 = dlog10(n2plusximpar(3))
+                  avg_impar = avg(log1,log2,log3)
+                  dif_impar = dif(log1,log2,log3,avg_impar)
                   dispersion = dif_pares + dif_impar
                   dif_pares_impar = abs(avg_pares-avg_impar)
@@ -4930,16 +4925,14 @@
                
                if (hplus_eq(i).eq.'Y') then
-                  avg_pares = ( dlog10(hplusxpares(1)) +
-     &                 dlog10(hplusxpares(2)) +
-     &                 dlog10( hplusxpares(3)) )*0.333
-                  dif_pares = ( abs(dlog10(hplusxpares(1))-avg_pares) + 
-     &                 abs(dlog10(hplusxpares(2))-avg_pares) +   
-     &                 abs(dlog10(hplusxpares(3))-avg_pares) ) * 0.333   
-                  avg_impar = ( dlog10(hplusximpar(1)) + 
-     &                 dlog10(hplusximpar(2)) +
-     &                 dlog10(hplusximpar(3)) )*0.333
-                  dif_impar = ( abs(dlog10(hplusximpar(1))-avg_impar) + 
-     &                 abs(dlog10(hplusximpar(2))-avg_impar) +   
-     &                 abs(dlog10(hplusximpar(3))-avg_impar) ) * 0.333
+                  log1 = dlog10(hplusxpares(1))
+                  log2 = dlog10(hplusxpares(2))
+                  log3 = dlog10(hplusxpares(3))
+                  avg_pares = avg(log1,log2,log3)
+                  dif_pares = dif(log1,log2,log3,avg_pares)
+                  log1 = dlog10(hplusximpar(1))
+                  log2 = dlog10(hplusximpar(2))
+                  log3 = dlog10(hplusximpar(3))
+                  avg_impar = avg(log1,log2,log3)
+                  dif_impar = dif(log1,log2,log3,avg_impar)
                   dispersion = dif_pares + dif_impar
                   dif_pares_impar = abs(avg_pares-avg_impar)
@@ -4951,16 +4944,14 @@
                
                if (co2plus_eq(i).eq.'Y') then
-                  avg_pares = ( dlog10(co2plusxpares(1)) +
-     &                 dlog10(co2plusxpares(2)) +
-     &                 dlog10(co2plusxpares(3)) )*0.333
-                  dif_pares = (abs(dlog10(co2plusxpares(1))-avg_pares)+ 
-     &                 abs(dlog10(co2plusxpares(2))-avg_pares) +   
-     &                 abs(dlog10(co2plusxpares(3))-avg_pares) ) * 0.333   
-                  avg_impar = ( dlog10(co2plusximpar(1)) + 
-     &                 dlog10(co2plusximpar(2)) +
-     &                 dlog10(co2plusximpar(3)) )*0.333
-                  dif_impar = (abs(dlog10(co2plusximpar(1))-avg_impar)+ 
-     &                 abs(dlog10(co2plusximpar(2))-avg_impar) +   
-     &                 abs(dlog10(co2plusximpar(3))-avg_impar) ) * 0.333
+                  log1 = dlog10(co2plusxpares(1))
+                  log2 = dlog10(co2plusxpares(2))
+                  log3 = dlog10(co2plusxpares(3))
+                  avg_pares = avg(log1,log2,log3)
+                  dif_pares = dif(log1,log2,log3,avg_pares)
+                  log1 = dlog10(co2plusximpar(1))
+                  log2 = dlog10(co2plusximpar(2))
+                  log3 = dlog10(co2plusximpar(3))
+                  avg_impar = avg(log1,log2,log3)
+                  dif_impar = dif(log1,log2,log3,avg_impar)
                   dispersion = dif_pares + dif_impar
                   dif_pares_impar = abs(avg_pares-avg_impar)
@@ -4972,16 +4963,14 @@
                
                if (o2plus_eq(i).eq.'Y') then
-                  avg_pares = ( dlog10(o2plusxpares(1)) +
-     &                 dlog10(o2plusxpares(2)) +
-     &                 dlog10(o2plusxpares(3)) )*0.333
-                  dif_pares = ( abs(dlog10(o2plusxpares(1))-avg_pares)+ 
-     &                 abs(dlog10(o2plusxpares(2))-avg_pares) +   
-     &                 abs(dlog10(o2plusxpares(3))-avg_pares) ) * 0.333   
-                  avg_impar = ( dlog10(o2plusximpar(1)) + 
-     &                 dlog10(o2plusximpar(2)) +
-     &                 dlog10(o2plusximpar(3)) )*0.333
-                  dif_impar = ( abs(dlog10(o2plusximpar(1))-avg_impar)+ 
-     &                 abs(dlog10(o2plusximpar(2))-avg_impar) +   
-     &                 abs(dlog10(o2plusximpar(3))-avg_impar) ) * 0.333
+                  log1 = dlog10(o2plusxpares(1))
+                  log2 = dlog10(o2plusxpares(2))
+                  log3 = dlog10(o2plusxpares(3))
+                  avg_pares = avg(log1,log2,log3)
+                  dif_pares = dif(log1,log2,log3,avg_pares)
+                  log1 = dlog10(o2plusximpar(1))
+                  log2 = dlog10(o2plusximpar(2))
+                  log3 = dlog10(o2plusximpar(3))
+                  avg_impar = avg(log1,log2,log3)
+                  dif_impar = dif(log1,log2,log3,avg_impar)
                   dispersion = dif_pares + dif_impar
                   dif_pares_impar = abs(avg_pares-avg_impar)
@@ -4993,16 +4982,14 @@
                
                if (noplus_eq(i).eq.'Y') then
-                  avg_pares = ( dlog10(noplusxpares(1)) +
-     &                 dlog10(noplusxpares(2)) +
-     &                 dlog10(noplusxpares(3)) )*0.333
-                  dif_pares = ( abs(dlog10(noplusxpares(1))-avg_pares)+ 
-     &                 abs(dlog10(noplusxpares(2))-avg_pares) +   
-     &                 abs(dlog10(noplusxpares(3))-avg_pares) ) * 0.333   
-                  avg_impar = ( dlog10(noplusximpar(1)) + 
-     &                 dlog10(noplusximpar(2)) +
-     &                 dlog10(noplusximpar(3)) )*0.333
-                  dif_impar = ( abs(dlog10(noplusximpar(1))-avg_impar)+ 
-     &                 abs(dlog10(noplusximpar(2))-avg_impar) +   
-     &                 abs(dlog10(noplusximpar(3))-avg_impar) ) * 0.333
+                  log1 = dlog10(noplusxpares(1))
+                  log2 = dlog10(noplusxpares(2))
+                  log3 = dlog10(noplusxpares(3))
+                  avg_pares = avg(log1,log2,log3)
+                  dif_pares = dif(log1,log2,log3,avg_pares)
+                  log1 = dlog10(noplusximpar(1))
+                  log2 = dlog10(noplusximpar(2))
+                  log3 = dlog10(noplusximpar(3))
+                  avg_impar = avg(log1,log2,log3)
+                  dif_impar = dif(log1,log2,log3,avg_impar)
                   dispersion = dif_pares + dif_impar
                   dif_pares_impar = abs(avg_pares-avg_impar)
